Attribute VB_Name = "M_API_Declares"
  Option Explicit
  ' demo project showing how to create splitter bars in VB
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.

    
  Public Const API_FALSE As Long = 0&
  Public Const API_TRUE As Long = 1&
  
  Public Const WM_SETREDRAW As Long = &HB

  Public Const EM_GETLINECOUNT As Long = &HBA&
  Public Const GWL_STYLE As Long = (-16)
  Public Const WS_VSCROLL As Long = &H200000

  Public Type POINTAPI
    x As Long
    y As Long
  End Type
  
  Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Public Declare Function ClipCursor Lib "user32" (lpRect As Any) As Long
  Public Declare Function ClientToScreen Lib "user32" (ByVal hWnd&, lpPoint As POINTAPI) As Long
  Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd&, ByVal wMsg&, ByVal wParam&, lParam As Any) As Long
  Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
  Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd&, ByVal nIndex&, ByVal dwNewLong&) As Long

  ' SetWindowPos Flags
  Public Const SWP_NOSIZE As Long = &H1&
  Public Const SWP_NOMOVE As Long = &H2&
  Public Const SWP_NOZORDER As Long = &H4&
  Public Const SWP_NOREDRAW As Long = &H8&
  Public Const SWP_NOACTIVATE As Long = &H10&
  Public Const SWP_FRAMECHANGED As Long = &H20&       '  The frame changed: send WM_NCCALCSIZE
  Public Const SWP_SHOWWINDOW As Long = &H40&
  Public Const SWP_HIDEWINDOW As Long = &H80&
  Public Const SWP_NOCOPYBITS As Long = &H100&
  Public Const SWP_NOOWNERZORDER As Long = &H200&     '  Don't do owner Z ordering
  
  Public Const SWP_DRAWFRAME As Long = SWP_FRAMECHANGED
  Public Const SWP_NOREPOSITION As Long = SWP_NOOWNERZORDER

  Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd&, ByVal hWndInsertAfter&, ByVal x&, ByVal y&, ByVal cx&, ByVal cy&, ByVal wFlags&) As Long

