VERSION 5.00
Begin VB.Form frmSplitters 
   Appearance      =   0  'Flat
   Caption         =   "Splitter Bar Demo"
   ClientHeight    =   6210
   ClientLeft      =   645
   ClientTop       =   1065
   ClientWidth     =   7365
   ForeColor       =   &H80000008&
   Icon            =   "frmSplitters.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   414
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   491
   Begin VB.PictureBox picAniLine 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1095
      Index           =   0
      Left            =   2400
      ScaleHeight     =   73
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   1
      TabIndex        =   5
      Top             =   2160
      Visible         =   0   'False
      Width           =   15
   End
   Begin VB.PictureBox picAniLine 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1095
      Index           =   1
      Left            =   2520
      ScaleHeight     =   73
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   1
      TabIndex        =   6
      Top             =   2160
      Visible         =   0   'False
      Width           =   15
   End
   Begin VB.PictureBox Splitter 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   495
      Index           =   1
      Left            =   3360
      MouseIcon       =   "frmSplitters.frx":0442
      MousePointer    =   99  'Custom
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   3
      Tag             =   "0"
      Top             =   1200
      Width           =   1215
   End
   Begin VB.PictureBox Splitter 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   495
      Index           =   0
      Left            =   2040
      MouseIcon       =   "frmSplitters.frx":0594
      MousePointer    =   99  'Custom
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   2
      Tag             =   "0"
      Top             =   1200
      Width           =   1215
   End
   Begin VB.TextBox TextRight 
      Height          =   495
      Index           =   0
      Left            =   2400
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "frmSplitters.frx":06E6
      Top             =   840
      Width           =   1215
   End
   Begin VB.ListBox ListLeft 
      Height          =   450
      Left            =   720
      TabIndex        =   0
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox TextRight 
      Height          =   495
      Index           =   1
      Left            =   3840
      MultiLine       =   -1  'True
      TabIndex        =   4
      Text            =   "frmSplitters.frx":06F5
      Top             =   840
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuManipulateList 
         Caption         =   "&Fill The List"
         Index           =   0
      End
      Begin VB.Menu mnuManipulateList 
         Caption         =   "&Remove Added Items"
         Index           =   1
      End
      Begin VB.Menu Sep0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAnimate 
         Caption         =   "Animate Splitter"
      End
      Begin VB.Menu Sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "frmSplitters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to create splitter bars in VB
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  'sets the width of the splitter bars
  Private Const SPLT_WDTH As Long = 4&
  
  'sets the horizontal & vertical
  'offsets of the controls
  Private Const CTRL_OFFSET As Long = 5&
  
  ' flag to indicate that a splitter recieved a mousedown
  Private m_fInitiateDrag As Boolean
  
  ' RECT structs to hold the area to contain the cursor
  Private m_CurVertRect As RECT
  Private m_CurHorzRect As RECT
    
Private Sub Form_Load()

  'set initial splitter bar positions
  With Splitter(0)
    .Move ScaleWidth \ 3, CTRL_OFFSET + 2, SPLT_WDTH, (ScaleHeight - (CTRL_OFFSET * 2)) - 4
    Splitter(1).Move (.Left + .Width) + 2, ScaleHeight \ 3, (ScaleWidth - _
                       ((.Left + .Width) + CTRL_OFFSET)) - 4, SPLT_WDTH
  End With
  
  ' fill the listbox
  mnuManipulateList_Click 1
  
  With TextRight(0)
    .Text = "This is a demonstration of how to implement a double splitter bar"
    .Text = .Text & " in a Visual Basic Project." & vbCrLf & vbCrLf
    .Text = .Text & "The splitter's actions are controlled through the MouseDown,"
    .Text = .Text & " MouseMove and MouseUp events of the Splitter Pictureboxes,"
    .Text = .Text & " and the Resize event of the form."
  End With
  
  With TextRight(1)
    .Text = "Add some text to the textboxes to see how they look and"
    .Text = .Text & " work with scrollbars.  You may also add items to the listbox"
    .Text = .Text & " through the commands in the 'File' menu." & vbCrLf & vbCrLf
    .Text = .Text & "Don't forget to check out the animated splitter bu checking the"
    .Text = .Text & " 'Animate Splitter' menu option."
  End With
    
End Sub

Private Sub Form_Resize()

  ' minimized do nothing
  If WindowState = vbMinimized Then Exit Sub
  
  ' maximized, lock update to avoid nasty window flashing
  If WindowState = vbMaximized Then Call SendMessage(hWnd, WM_SETREDRAW, API_FALSE, ByVal 0&)
  
  Screen.MousePointer = vbHourglass
  
  ' handle minimum height. if you were to remove the
  ' controlbox you would need to handle minimum width also
  If Height < 1500 Then Height = 2000
  
  
  Dim FrameWidth As Integer
  ' the width of the window frame
  FrameWidth = ((Width \ Screen.TwipsPerPixelX) - ScaleWidth) \ 2
  
  ' handle a form resize that hides the vertical splitter
  If ((ScaleWidth - CTRL_OFFSET) - (Splitter(0).Left + Splitter(0).Width)) < 12 Then
    Splitter(0).Left = ScaleWidth - ((CTRL_OFFSET * 4) + (FrameWidth * 2))
  End If
  
  ' handle a form resize that hides the horizontal splitter
  If ((ScaleHeight - CTRL_OFFSET) - (Splitter(1).Top + Splitter(1).Height)) < 12 Then
    Splitter(1).Top = ScaleHeight - ((TextHeight("A") + (FrameWidth * 2)) + (CTRL_OFFSET * 4))
  End If
  
  
  ' set vars for figuring the height of the controls
  Dim X2&, height1&, width1&, width2&
  
  height1 = ScaleHeight - (CTRL_OFFSET * 2)
  width1 = ListLeft.Width
  X2 = CTRL_OFFSET + width1 + SPLT_WDTH - 1
  width2 = ScaleWidth - X2 - CTRL_OFFSET
  
  ' move the left list
  ListLeft.Move CTRL_OFFSET - 1, CTRL_OFFSET, Splitter(0).Left - Splitter(0).Width, height1
  
  ' handle the form height since IntegralHeight for the list is set to true.
  If WindowState = vbNormal Then Height = (((ListLeft.Top + ListLeft.Height) + CTRL_OFFSET) _
           + (((Height \ Screen.TwipsPerPixelY) - ScaleHeight))) * Screen.TwipsPerPixelY
  
  
  ' resize the verticle splitter
  Splitter(0).Height = ListLeft.Height - 4
  
  ' move the right top textbox
  TextRight(0).Move (Splitter(0).Left + Splitter(0).Width), CTRL_OFFSET, _
                 ((ScaleWidth - (Splitter(0).Left + Splitter(0).Width)) _
                 - CTRL_OFFSET) + 2, Splitter(1).Top - CTRL_OFFSET
                 
  ' check to see if this textbox needs scrollbar modifications
  CheckScrollBar TextRight(0)
  
  
  ' resize the horizontal splitter
  Splitter(1).Move (Splitter(0).Left + Splitter(0).Width) + 2, _
                                      Splitter(1).Top, TextRight(0).Width - 4
  
  
  ' move the right bottom textbox
  TextRight(1).Move TextRight(0).Left, Splitter(1).Top + Splitter(1).Height, _
                 TextRight(0).Width, (ListLeft.Top + ListLeft.Height) - _
                 (Splitter(1).Top + Splitter(1).Height)
                 
  ' check to see if this textbox needs scrollbar modifications
  CheckScrollBar TextRight(1)
  
                 
  ' sets the distance from the edge of the wall that the splitter may be moved.
  ' necessary because each of the controls have a minimum width and height.
  Const MIN_VERT_BUFFER As Integer = 20
  Const MIN_HORZ_BUFFER As Integer = 13
  ' the width of the cursor
  Const CURSOR_DEDUCT As Integer = 10
             
  ' set the ClipCursor vertical Rect
  With m_CurVertRect
    .Left = GetScreenPoint(ListLeft.Left + MIN_VERT_BUFFER, ListLeft.Top, True)
    .Top = GetScreenPoint(ListLeft.Left, ListLeft.Top + CURSOR_DEDUCT, False)
    .Right = GetScreenPoint((TextRight(0).Left + TextRight(0).Width) _
                                      - MIN_VERT_BUFFER, TextRight(0).Top, True)
    .Bottom = GetScreenPoint(ListLeft.Left, (ListLeft.Top + ListLeft.Height) _
                                       - CURSOR_DEDUCT, False)
  End With
  
  ' set the ClipCursor horizontal Rect
  With m_CurHorzRect
    .Left = GetScreenPoint((Splitter(0).Left + Splitter(0).Width) _
                                      + CURSOR_DEDUCT, ListLeft.Top, True)
    .Top = m_CurVertRect.Top + MIN_HORZ_BUFFER
    .Right = (m_CurVertRect.Right + MIN_VERT_BUFFER) - CURSOR_DEDUCT
    .Bottom = m_CurVertRect.Bottom - MIN_HORZ_BUFFER
  End With
  
  Screen.MousePointer = vbDefault
  
  ' if it's locked unlock the window
  If WindowState = vbMaximized Then Call SendMessage(hWnd, WM_SETREDRAW, API_TRUE, ByVal 0&)

End Sub

Private Sub mnuAnimate_Click()
  With mnuAnimate
    .Checked = Not .Checked
  End With
End Sub

Private Sub mnuExit_Click()
    
  Unload Me
    
End Sub

Private Sub mnuManipulateList_Click(index As Integer)
  ' add or remove items to/from the listbox so that
  ' we can see how it looks with a scrollbar
  
  Static s$
  
  Select Case index
    Case 0
      Dim i&, j&
      
      With ListLeft
        For i = 0 To ((.Height \ TextHeight("A")) - .ListCount) \ .ListCount
          s = s & "And More "
          For j = 0 To 8
            .AddItem s & .List(j)
          Next
        Next
      End With
      
    Case 1
      With ListLeft
      
        Call SendMessage(.hWnd, WM_SETREDRAW, API_FALSE, ByVal 0&)
        .Clear
      
        s = vbNullString
      
      
        .AddItem "Oranges"
        .AddItem "Apples"
        .AddItem "Bananas"
        .AddItem "Pears"
        .AddItem "Cranberries"
        .AddItem "Pommagranats"
        .AddItem "Elephants"
        .AddItem "Avacados"
        .AddItem "Mangos"
        
        Call SendMessage(.hWnd, WM_SETREDRAW, API_TRUE, ByVal 0&)
      End With
      

  End Select
  
End Sub

Private Sub Splitter_MouseDown(index As Integer, button As Integer, Shift As Integer, x As Single, y As Single)

  ' if the left button is down set the flag
  If button = 1 Then m_fInitiateDrag = True
  
End Sub

Private Sub Splitter_MouseMove(index As Integer, button As Integer, Shift As Integer, x As Single, y As Single)

  ' if the flag isn't set then the left button wasn't
  ' pressed while the mouse was over one of the splitters
  If m_fInitiateDrag <> True Then Exit Sub

  With Splitter(index)
    ' if the left button is down then we want to move the splitter
    If button = 1 Then ' if the Tag is false then we need to set the splitter
      If .Tag = False Then ' in the correct location and clip the cursor.
        
        If Not mnuAnimate.Checked Then .BackColor = vbButtonShadow '<- set the "dragging" color here
        
        Select Case index
          Case 0       ' figure out which Rect to use and which splitter to orient to
            Call ClipCursor(m_CurVertRect)
            
            If mnuAnimate.Checked Then
              picAniLine(0).Move x - 3, .Top, 1, .Height
              picAniLine(1).Move x + 2, .Top, 1, .Height
            End If
            
          Case 1
            Call ClipCursor(m_CurHorzRect)
            
            If mnuAnimate.Checked Then
              picAniLine(0).Move .Left, y - 3, .Width, 1
              picAniLine(1).Move .Left, y + 2, .Width, 1
            End If
            
        End Select
        
        If mnuAnimate.Checked Then
          With picAniLine(0)
            .Visible = True
            .ZOrder
          End With
          With picAniLine(1)
            .Visible = True
            .ZOrder
          End With
          
        Else
          .ZOrder
        End If
        
        .Tag = True
      End If
          
      
      Select Case index ' move the splitter to the appropriate place
        Case 0
          If mnuAnimate.Checked Then
            
            picAniLine(0).Left = .Left + (x - 2)
            picAniLine(1).Left = .Left + (x + 2)
          Else
            .Left = (.Left + x) - (SPLT_WDTH \ 3)
            
            ' For an interesting effect you can uncomment the next line.  You will
            ' also need to add code to change the color of both splitters when the
            ' vertical splitter is moved if you wish to implement this effect.
            'Splitter(index + 1).Move .Left + .Width, _
                     Splitter(index + 1).Top, ((ScaleWidth - (.Left _
                     + .Width)) - CTRL_OFFSET) + 2
          End If
          
        Case 1
          If mnuAnimate.Checked Then
            picAniLine(0).Top = .Top + (y - 2)
            picAniLine(1).Top = .Top + (y + 2)
          Else
            .Top = (.Top + y) - (SPLT_WDTH \ 3)
          End If
          
      End Select
      
      ' if this is the first time into this sub for
      ' this *splitter move* event, lock out recursive
      ' entry and go into the timer loop
      Static bInLoop As Boolean
      
      If mnuAnimate.Checked Then
        If bInLoop Then Exit Sub
        bInLoop = True
        Do Until m_fInitiateDrag = False
          AnimatEffects  ' keep calling the Animate sub
          DoEvents    '  until the mouse is released
        Loop
        bInLoop = False
      End If
      
    End If
  End With
  
End Sub

Private Sub Splitter_MouseUp(index As Integer, button As Integer, Shift As Integer, x As Single, y As Single)
  
  ' if the left button is the one being released we need to reset
  ' the Tag, flag and cancel ClipCursor.  We also need to hide the
  If button = 1 Then  ' animated line pics, move the Splitter pics
                      ' and then call form_resize to move the list
                      ' and text boxes.
    With Splitter(index)
      .Tag = False
      m_fInitiateDrag = False
      Call ClipCursor(ByVal 0&)
     
      If mnuAnimate.Checked Then
        picAniLine(0).Visible = False
        picAniLine(1).Visible = False
    
        Select Case index
          Case False         ' move the appropriate splitter
            .Left = (.Left + x) - (SPLT_WDTH \ 3)
         
          Case 1
            .Top = (.Top + y) - (SPLT_WDTH \ 3)
           
        End Select
        
      Else
        .BackColor = vbButtonFace  '<- set to original color
      End If
    End With
    
    Form_Resize
  End If
  
End Sub

Private Function GetScreenPoint(x As Long, y As Long, bReturnX As Boolean)
  ' this function calls ClientToScreen to convert the passed client point to
  ' a screen point and returns the x or y point depending on the value of bReturnX
  
  Dim pt As POINTAPI
  
  ' plug the point into the point struct
  pt.x = x
  pt.y = y
  
  ' call for the conversion
  Call ClientToScreen(hWnd, pt)
  
  ' return the desired value
  If bReturnX Then
    GetScreenPoint = pt.x
  Else
    GetScreenPoint = pt.y
  End If
  
End Function

Private Sub CheckScrollBar(cTB As TextBox)
  ' this sub checks the passed textbox to see if
  ' it needs to have a scrollbar added or removed
  
  Dim fWhdStyleBits&, bForceRepaint As Boolean
  
  With cTB
    ' get the current style bits
    fWhdStyleBits = GetWindowLong(.hWnd, GWL_STYLE)
  
    ' get the number of lines in the textbox and multiply by the height of
    ' one line in the form (the form's font is set to the same as the textbox).
    ' if the lines are greater than the height of the textbox add a scrollbar.
    ' the '6' is the width of the 3D border of the textbox multiplied by 2 (top & bottom)
    If ((SendMessage(.hWnd, EM_GETLINECOUNT, 0&, ByVal 0&) * TextHeight("A")) + 6) > .Height Then
            
      ' change the style bits to add a scrollbar
      Call SetWindowLong(.hWnd, GWL_STYLE, fWhdStyleBits Or WS_VSCROLL)
    
      bForceRepaint = True
    
    ElseIf (fWhdStyleBits And WS_VSCROLL) Then
  
      ' change the style bits to remove the scrollbar
      Call SetWindowLong(.hWnd, GWL_STYLE, fWhdStyleBits Xor WS_VSCROLL)
    
      bForceRepaint = True
    End If
  
  
    If bForceRepaint Then
      ' allow the textbox to update itself so the scrollbar will be drawn correctly
      DoEvents
      
      ' make the textbox redraw it's frame so that the scrollbar will be added or removed
      Call SetWindowPos(.hWnd, 0&, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED)
    End If
    
  End With

End Sub

Private Sub TextRight_Change(index As Integer)

  ' check to see if this textbox needs scrollbar modifications
  CheckScrollBar TextRight(index)

End Sub

Private Sub AnimatEffects()

  ' this sub animates the lines for the splitter

  ' sets the length of the colored bars
  Const BAR_LEN As Integer = 40
  
  Static bSetColor As Boolean, nRandom&
  Dim i&, nColor&
  
  ' toggle the color of the bar each time through
  ' to give the illusion of transparency
  bSetColor = Not bSetColor
  If bSetColor Then
    nColor = vbButtonFace
  Else
    nColor = vbWindowBackground
  End If

  ' incriment the draw position of
  '  the lines to create movement
  nRandom = nRandom + 3
  If nRandom > 40 Then nRandom = 0
   
  If Splitter(0).Tag Then  ' move in the appropriate direction
  
    ' the bar is followed by a shorter bar that matches the background of the list
    ' and text boxes so that it appears transparent.  the bars are offset from each other
    For i = -BAR_LEN To picAniLine(0).Height Step BAR_LEN + 5
      picAniLine(0).Line (0, i + nRandom)-(0, (i + BAR_LEN) + nRandom), nColor&
      picAniLine(0).Line (0, (i + BAR_LEN) + nRandom)-(0, ((i + BAR_LEN) + nRandom) + 5), vbWindowBackground
      
      picAniLine(1).Line (0, (i + nRandom) + 3)-(0, ((i + BAR_LEN) + nRandom) + 3), nColor&
      picAniLine(1).Line (0, ((i + BAR_LEN) + nRandom) + 3)-(0, (((i + BAR_LEN) + nRandom) + 5) + 3), vbWindowBackground
    Next
 
  Else
  
    For i = -BAR_LEN To picAniLine(0).Width Step BAR_LEN + 10
      picAniLine(0).Line (i + nRandom, 0)-((i + BAR_LEN) + nRandom, 0), nColor&
      picAniLine(0).Line ((i + BAR_LEN) + nRandom, 0)-(((i + BAR_LEN) + nRandom) + 5, 0), vbWhite
      
      picAniLine(1).Line ((i + nRandom) + 3, 0)-(((i + BAR_LEN) + nRandom) + 3, 0), nColor&
      picAniLine(1).Line (((i + BAR_LEN) + nRandom) + 3, 0)-((((i + BAR_LEN) + nRandom) + 5) + 3, 0), vbWhite
    Next
  
  End If
  
End Sub
